//*****************************************************
//
// .cpp
//
// Descricao
//
// 
//*****************************************************

#include <stdio.h>
#include <GL/glut.h>

// Funo callback de redesenho da janela de visualizao
void Desenha(void)
{
  
  // Limpa a janela de vizualizao com a cor
  // de fundo definida previamente
	glClear(GL_COLOR_BUFFER_BIT);
	
	// Altera a cor de desenho atual para azul
	glColor3f(0.0f, 0.0f, 1.0f);
	
	// Desenha um quadrado
	glBegin(GL_QUADS);
	  glVertex2f(0.0f,10.0f);
	  glVertex2f(10.0f,10.0f);
	  glVertex2f(10.0f,0.0f);
	  glVertex2f(0.0f,0.0f);
  glEnd();       
  
  // Executa os comandos OpenGL
  glFlush();     	  

}

// Funo callback chamada quando o tamanho da janela  alterado 
void AlteraTamanhoJanela(GLsizei w, GLsizei h)
{
	// Evita a divisao por zero
	if(h == 0) {
    h = 1;
  }
                           
	// Especifica as dimenses da Viewport
	glViewport(0, 0, w, h);

	// Inicializa o sistema de coordenadas
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

  float fator=0.0;
  if (w <= h) {
    fator=((1.0*h)/w);
		gluOrtho2D (-50.0f, 50.0f, -50.0f*fator, 50.0f*fator);
  }
	else {
    fator=(1.0*w)/h;
		gluOrtho2D (-50.0f*fator, 50.0f*fator, -50.0f, 50.0f);
  }
  
}

// Funo callback chamada para gerenciar eventos de teclas
void Teclado (unsigned char key, int x, int y)  
{

  
}

// Funo responsvel por inicializar parmetros e variveis
void Inicializa (void)
{   
	// Define a cor de fundo da janela de visualizao como branca
	glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
}

// Programa Principal 
int main(int argc, char *argv[])
{
	// Define do modo de operao da GLUT (GL Utility Toolkit)
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); 
 
	// Especifica a posio inicial da janela GLUT
	glutInitWindowPosition(10,10); 
    
	// Especifica o tamanho inicial em pixels da janela GLUT
	glutInitWindowSize(450,450); 
 
	// Cria a janela passando como argumento o ttulo da mesma
	glutCreateWindow(argv[0]);
 
	// Registra a funo callback de redesenho da janela de visualizao
	glutDisplayFunc(Desenha);
  
	// Registra a funo callback de redimensionamento da janela de visualizao
	glutReshapeFunc(AlteraTamanhoJanela);

	// Registra a funo callback para tratamento das teclas ASCII
	glutKeyboardFunc (Teclado);

	// Chama a funo responsvel por fazer as inicializaes 
	Inicializa();
 
	// Inicia o processamento e aguarda interaes do usurio
	glutMainLoop();
 
	return 0;
}
